window.Gleam.initSearch([{"doc":"surreal_gleam","title":"surreal_gleam","content":"# surreal_gleam\n\n[![Package Version](https://img.shields.io/hexpm/v/surreal_gleam)](https://hex.pm/packages/surreal_gleam)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/surreal_gleam/)\n\n```sh\ngleam add surreal_gleam\n```\n```gleam\nimport gleam/io\nimport gleam/list\nimport surreal_gleam/sg_engine\nimport surreal_gleam/types\n\npub fn main() {\n  let bearer = sg_engine.root_sign_in(&quot;Me&quot;, &quot;123&quot;)\n  let table =\n    []\n    |&gt; sg_engine.add_field(&quot;FavoriteFoods&quot;, types.Array(types.Int))\n    |&gt; sg_engine.add_field(&quot;IsVicious&quot;, types.Boolean)\n    |&gt; sg_engine.add_default_field(\n      &quot;AlwaysDefaultsToOne&quot;,\n      types.Int,\n      types.DefaultInt(1),\n    )\n    |&gt; sg_engine.create_table_schemafull(&quot;Monster&quot;)\n\n  let create_namespace = sg_engine.create_namespace(&quot;Test&quot;)\n  let namespace = sg_engine.use_namespace(&quot;Test&quot;)\n  let create_database = sg_engine.create_database(&quot;Test&quot;)\n  let database = sg_engine.use_database(&quot;Test&quot;)\n\n  let transaction = case table {\n    Ok(types.Table(_table_name, _defintion, table)) -&gt; {\n      list.append(\n        [create_namespace, namespace, create_database, database],\n        table,\n      )\n    }\n    Error(x) -&gt; {\n      []\n    }\n  }\n  case bearer {\n    Ok(token) -&gt; {\n      case sg_engine.execute_transaction(transaction, token) {\n        Ok(x) -&gt; {\n          let _ = io.println(x)\n        }\n        Error(x) -&gt; {\n          let _ = io.println_error(x)\n        }\n      }\n    }\n    Error(error) -&gt; {\n      let _ = io.println_error(error)\n    }\n  }\n}\n\n\n```\n\n\n\nFurther documentation can be found at &lt;https://hexdocs.pm/surreal_gleam&gt;.\n\n## TODO\n```sh\n|&gt; Finish mapping Surreal Types\n|&gt; Finish Table generating code\n|&gt; generate {{Model}}.gleam for all tables\n|&gt; generate decoders for all tables\n|&gt; create basic query DSL\n|&gt; create advanced query DSL\n|&gt; back_end jobs that run on your database written in gleam?\n|&gt; so much more...\n```\n## Development\n\n```sh\ngleam run   # Run the project\ngleam test  # Run the tests\ngleam shell # Run an Erlang shell\n```\n","url":"index.html"},{"doc":"models","title":"Message","content":"pub type Message {\n  MyMessage(String)\n}\n\nMyMessage(String)\n\n\nSynonyms:\nmodels.Message\nmodels Message","url":"models.html#Message"},{"doc":"models","title":"models","content":"","url":"models.html"},{"doc":"types","title":"DefaultFieldType","content":"pub type DefaultFieldType {\n  DefaultInt(val: Int)\n  DefaultString(val: String)\n  DefaultArray(val: List(DefaultFieldType))\n  DefaultNone\n}\n\nDefaultInt(val: Int)\n\n\nDefaultString(val: String)\n\n\nDefaultArray(val: List(DefaultFieldType))\n\n\nDefaultNone\n\n\nSynonyms:\ntypes.DefaultFieldType\ntypes DefaultFieldType","url":"types.html#DefaultFieldType"},{"doc":"types","title":"EmittedLines","content":"pub type EmittedLines =\n  List(Result(String, String))\n\n\nSynonyms:\ntypes.EmittedLines\ntypes EmittedLines","url":"types.html#EmittedLines"},{"doc":"types","title":"Entity","content":"pub type Entity =\n  List(Field)\n\n\nSynonyms:\ntypes.Entity\ntypes Entity","url":"types.html#Entity"},{"doc":"types","title":"Field","content":"pub type Field =\n  #(String, FieldType, Result(String, String))\n\n\nSynonyms:\ntypes.Field\ntypes Field","url":"types.html#Field"},{"doc":"types","title":"FieldType","content":"pub type FieldType {\n  Array(FieldType)\n  Set(FieldType)\n  Boolean\n  None\n  Null\n  Int\n  Float\n  Decimal\n  String\n  DateTime\n  Record\n  Geometry(GeometryType)\n  Object\n  Option(FieldType)\n}\n\nArray(FieldType)\n\n\nSet(FieldType)\n\n\nBoolean\n\n\nNone\n\n\nNull\n\n\nInt\n\n\nFloat\n\n\nDecimal\n\n\nString\n\n\nDateTime\n\n\nRecord\n\n\nGeometry(GeometryType)\n\n\nObject\n\n\nOption(FieldType)\n\n\nSynonyms:\ntypes.FieldType\ntypes FieldType","url":"types.html#FieldType"},{"doc":"types","title":"GeometryType","content":"pub type GeometryType {\n  Feature\n  Point\n  LineString\n  Polygon\n  MultiPoint\n  MultiLine\n  MultiPolygon\n  Collection\n}\n\nFeature\n\n\nPoint\n\n\nLineString\n\n\nPolygon\n\n\nMultiPoint\n\n\nMultiLine\n\n\nMultiPolygon\n\n\nCollection\n\n\nSynonyms:\ntypes.GeometryType\ntypes GeometryType","url":"types.html#GeometryType"},{"doc":"types","title":"TableEntity","content":"pub type TableEntity {\n  Table(\n    table_name: String,\n    definition: Entity,\n    code_gen: EmittedLines,\n  )\n}\n\nTable(\n  table_name: String,\n  definition: Entity,\n  code_gen: EmittedLines,\n)\n\n\nSynonyms:\ntypes.TableEntity\ntypes TableEntity","url":"types.html#TableEntity"},{"doc":"types","title":"types","content":"","url":"types.html"},{"doc":"sg_engine","title":"add_default_field","content":"pub fn add_default_field(\n  e: List(#(String, FieldType, Result(String, String))),\n  field: String,\n  field_type: FieldType,\n  d: DefaultFieldType,\n) -&gt; List(#(String, FieldType, Result(String, String)))\n\nSynonyms:\nsg_engine.add_default_field\nsg_engine add_default_field","url":"sg_engine.html#add_default_field"},{"doc":"sg_engine","title":"add_field","content":"pub fn add_field(\n  e: List(#(String, FieldType, Result(String, String))),\n  field: String,\n  field_type: FieldType,\n) -&gt; List(#(String, FieldType, Result(String, String)))\n\nSynonyms:\nsg_engine.add_field\nsg_engine add_field","url":"sg_engine.html#add_field"},{"doc":"sg_engine","title":"create_database","content":"pub fn create_database(name: String) -&gt; Result(String, String)\n\nSynonyms:\nsg_engine.create_database\nsg_engine create_database","url":"sg_engine.html#create_database"},{"doc":"sg_engine","title":"create_namespace","content":"pub fn create_namespace(name: String) -&gt; Result(String, String)\n\nSynonyms:\nsg_engine.create_namespace\nsg_engine create_namespace","url":"sg_engine.html#create_namespace"},{"doc":"sg_engine","title":"create_table_schemafull","content":"pub fn create_table_schemafull(\n  entity_definition: List(\n    #(String, FieldType, Result(String, String)),\n  ),\n  name: String,\n) -&gt; Result(TableEntity, List(Result(String, String)))\n\nSynonyms:\nsg_engine.create_table_schemafull\nsg_engine create_table_schemafull","url":"sg_engine.html#create_table_schemafull"},{"doc":"sg_engine","title":"create_table_schemaless","content":"pub fn create_table_schemaless(\n  entity_definition: List(\n    #(String, FieldType, Result(String, String)),\n  ),\n  name: String,\n) -&gt; Result(TableEntity, List(Result(String, String)))\n\nSynonyms:\nsg_engine.create_table_schemaless\nsg_engine create_table_schemaless","url":"sg_engine.html#create_table_schemaless"},{"doc":"sg_engine","title":"emit_fields","content":"pub fn emit_fields(\n  x: List(#(String, FieldType, Result(String, String))),\n  table: String,\n) -&gt; List(Result(String, String))\n\nSynonyms:\nsg_engine.emit_fields\nsg_engine emit_fields","url":"sg_engine.html#emit_fields"},{"doc":"sg_engine","title":"exec","content":"pub fn exec(lines: List(Result(String, String))) -&gt; Nil\n\nSynonyms:\nsg_engine.exec\nsg_engine exec","url":"sg_engine.html#exec"},{"doc":"sg_engine","title":"execute_transaction","content":"pub fn execute_transaction(\n  statements: List(Result(String, String)),\n  token: String,\n) -&gt; Result(String, String)\n\nSynonyms:\nsg_engine.execute_transaction\nsg_engine execute_transaction","url":"sg_engine.html#execute_transaction"},{"doc":"sg_engine","title":"find_field","content":"pub fn find_field(x: FieldType) -&gt; String\n\nSynonyms:\nsg_engine.find_field\nsg_engine find_field","url":"sg_engine.html#find_field"},{"doc":"sg_engine","title":"generate","content":"pub fn generate(\n  e: List(#(String, FieldType, Result(String, String))),\n) -&gt; List(#(String, FieldType, Result(String, String)))\n\nSynonyms:\nsg_engine.generate\nsg_engine generate","url":"sg_engine.html#generate"},{"doc":"sg_engine","title":"root_sign_in","content":"pub fn root_sign_in(\n  username: String,\n  password: String,\n) -&gt; Result(String, String)\n\nSynonyms:\nsg_engine.root_sign_in\nsg_engine root_sign_in","url":"sg_engine.html#root_sign_in"},{"doc":"sg_engine","title":"use_database","content":"pub fn use_database(name: String) -&gt; Result(String, String)\n\nSynonyms:\nsg_engine.use_database\nsg_engine use_database","url":"sg_engine.html#use_database"},{"doc":"sg_engine","title":"use_namespace","content":"pub fn use_namespace(name: String) -&gt; Result(String, String)\n\nSynonyms:\nsg_engine.use_namespace\nsg_engine use_namespace","url":"sg_engine.html#use_namespace"},{"doc":"sg_engine","title":"sg_engine","content":"","url":"sg_engine.html"}]);